/**
* Script: main.js
* Written by: Andrew Helenius
* Updated: 2/21/2015
**/

RequireScript("testsuite.js");
RequireScript("query.js");
RequireScript("link.js");
RequireScript("lazy.js");

function even(i) { return i % 2 == 0; };
function three(i) { return i % 3 == 0; };
function timesten(i) { return i * 10; };
function add(i) { return ++i; };
function isInt(i) { return Math.floor(i) == i; }
function div3(i) { return i / 3; }
function cool(i) { return i + i % 3; }
function noop() { };

var test = new TestSuite();

function genArray(len) {
	var l = [];
	while(len--) l[len] = len;
	return l;
}

function isPrime(n) {
	for (var i = 2, l = n / 2; i < l; ++i) {
		if (n % i == 0) return false;
	}
	return true;
}

function game()
{
	var arr = genArray(1000000);

	var La = Lazy(arr).where(even).map(add).map(div3).where(isInt);
	var Li = Link(arr).where(even).map(add).map(div3).where(isInt);
	var Qu = Query.from(arr).where(even).map(add).map(div3).where(isInt);
	
	test.addTest("Link", function() { var n = Li.each(noop); }, 5);
	test.addTest("Lazy", function() { var n = Li.each(noop); }, 5);
	test.addTest("Query", function() { var n = Qu.each(noop); }, 5);

	Abort(test.run());
}
