/**
* Script: testsuite.js
* Written by: Radnen
* Updated: 1/1/2014
**/

function TestSuite()
{
	this.tests = [];
}

TestSuite.prototype.addTest = function(name, func, times) {
	this.tests.push({name: name, func: func, times: times});
}

TestSuite.prototype.run = function() {
	var printout = "";
	for (var t = 0; t < this.tests.length; ++t) {
		var test = this.tests[t];
		var trials = [];
		for (var i = 0; i < test.times; ++i) {
			var time = GetTime();
			test.func();
			trials[i] = GetTime() - time;
		}
		printout += test.name + ": " + this.avg(trials) + "ms\n";
	}
	return printout;
}

TestSuite.prototype.avg = function(array) {
	if (array.length == 0) return 0;
	var avg = 0;
	for (var i = 0; i < array.length; ++i) avg += array[i];
	return Math.floor(avg / array.length);
}

TestSuite.prototype.toString = function() { return this.printout; }